package com.example.tdl.web;

import com.example.tdl.domain.dto.RestResponse;
import com.example.tdl.domain.dto.Result;
import com.google.gson.JsonObject;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/service")
public class ServiceController {

    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    @GetMapping(value = "/getThreadPool")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
            @ApiImplicitParam(paramType="header", name = "AccountLanguage", value = "language", required = false, dataType = "String"),
    })
    public ResponseEntity<String> getThreadPool() {
        try {
            JsonObject jsonObject = new JsonObject();
            jsonObject.addProperty("poolSize", taskExecutor.getPoolSize());
            jsonObject.addProperty("activeThreads", taskExecutor.getActiveCount());

            return new RestResponse(Result.STATUS_OK, jsonObject.toString())
                    .getResponseEntity();
        } catch (Exception e) {
            return new RestResponse(Result.STATUS_ERROR, "Exception: " + e.getMessage())
                    .getResponseEntity();
        }
    }
}
